function p = h2bits(varargin)
%H2BITS binary (cross-)entropy in bits for a Bernoulli distribution
%
%    h2bits(p) = h2nats(p) / log(2)
% h2bits(p, q) = h2nats(p, q) / log(2)
%
% See also: H2NATS

% Iain Murray, November 2007

p = h2nats(varargin{:}) / log(2);
